package BBUVA;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.423926E6-B368-AB11-4099-04C8E11634D1]
// </editor-fold> 
public class Sucursal {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.ED08B967-6F40-4C39-25A9-F88A44C7EF9F]
    // </editor-fold> 
    private ArrayList<Producto> mProducto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7D58854E-FD70-DFB5-097B-5B6E8BFBDC22]
    // </editor-fold> 
    private ArrayList<Remesa> mRemesa;

    private ArrayList<Titular> mTitular;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.DFF33FA2-D8CA-4E99-CD00-4DB0874EE7DF]
    // </editor-fold> 
    public Sucursal () {
        mProducto = new ArrayList<Producto>();
        mRemesa = new ArrayList<Remesa>();
        mTitular = new ArrayList<Titular>();
    }

    public void addProducto(Producto val) {
        mProducto.add(val);
    }

    public void addTitular(Titular val) {
        mTitular.add(val);
    }

    public String buscaNumeroNuevo() {
        ArrayList<String> lista=new ArrayList();
        for(int i=0;i<mProducto.size();i++)
            lista.add(mProducto.get(i).getNumeroProducto());

        String numero="20984002161";
        String aux="";

        for(long cont=0;cont<1000000000;cont++) {
            aux=Long.toString(cont);
            for(int i=aux.length();i<9;i++) aux="0"+aux;
            if(!lista.contains(numero+aux))break;
        }
        numero+=aux;
        return numero;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.647026DE-0EB8-E50D-09D3-2224C3610948]
    // </editor-fold> 
    public ArrayList<Producto> getProducto () {
        return mProducto;
    }

    public boolean ingreso(String nCuenta,String importe) throws ParseException {
        Calendar actual= Calendar.getInstance();
        return this.anadirMovimiento(nCuenta, Float.parseFloat(importe), "ingreso", actual.getTime());
    }

    public void nuevaCuentaCorriente(String nID) {
        Producto nuevo = new CuentaCorriente();
        nuevo.setNumeroProducto(this.buscaNumeroNuevo());
        int i=this.posTitularID(nID);
        nuevo.addTitular(this.getTitular().get(i));
        this.getTitular().get(i).addProducto(nuevo);
        this.addProducto(nuevo);
    }

    public void nuevaLibretaAhorro(String nID) {
        Producto nuevo = new LibretaAhorro();
        nuevo.setNumeroProducto(this.buscaNumeroNuevo());
        int i=this.posTitularID(nID);
        nuevo.addTitular(this.getTitular().get(i));
        this.getTitular().get(i).addProducto(nuevo);
        this.addProducto(nuevo);
    }

    public boolean nuevaPersona(String nID, String nombre) {
        if(nID.trim().compareTo("")==0 || nombre.trim().compareTo("")==0) return false;
        else {
            Persona p=new Persona();
            p.setId(nID);
            p.setNombre(nombre);
            this.addTitular(p);
            return true;
        }
    }

    public boolean nuevaEmpresa(String nID, String nombre) {
        if(nID.trim().compareTo("")==0 || nombre.trim().compareTo("")==0) return false;
        else {
            Empresa e=new Empresa();
            e.setId(nID);
            e.setNombre(nombre);
            this.addTitular(e);
            return true;
        }
    }

    public void nuevoPrestamoHipotecario(String nID) {
        Producto nuevo = new PrestamoHipotecario();
        nuevo.setNumeroProducto(this.buscaNumeroNuevo());
        int i=this.posTitularID(nID);
        nuevo.addTitular(this.getTitular().get(i));
        this.getTitular().get(i).addProducto(nuevo);
        this.addProducto(nuevo);
    }

    public void nuevoPrestamoPersonal(String nID) {
        Producto nuevo = new PrestamoPersonal();
        nuevo.setNumeroProducto(this.buscaNumeroNuevo());
        int i=this.posTitularID(nID);
        nuevo.addTitular(this.getTitular().get(i));
        this.getTitular().get(i).addProducto(nuevo);
        this.addProducto(nuevo);
    }

    public boolean reintegro(String nCuenta, String importe) {
        Calendar actual= Calendar.getInstance();
        return this.anadirMovimiento(nCuenta, Float.parseFloat(importe)*-1, "reintegro", actual.getTime());
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FFAA13FB-6ADF-1D40-4C07-D65505B675CB]
    // </editor-fold> 
    public void setProducto (ArrayList<Producto> val) {
        this.mProducto = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.01112135-40D4-ADD3-FAAE-2CCAB8646BF7]
    // </editor-fold> 
    public ArrayList<Remesa> getRemesa () {
        return mRemesa;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1C2292DD-91D3-5C56-8A12-D13F0620AB5B]
    // </editor-fold> 
    public void setRemesa (ArrayList<Remesa> val) {
        this.mRemesa = val;
    }

    public ArrayList<Titular> getTitular () {
        return mTitular;
    }

    public void setTitular (ArrayList<Titular> val) {
        this.mTitular = val;
    }

    public boolean transferenciaInterna(String origen, String destino, String importe) {
        Calendar c=Calendar.getInstance();
        if(origen.compareTo(destino)!=0)
            if(this.anadirMovimiento(origen, Float.parseFloat(importe)*-1, "Transferencia interna", c.getTime()) == true) {
                this.anadirMovimiento(destino, Float.parseFloat(importe), "Transferencia interna", c.getTime());
                return true;
            }
        return false;
    }

    public boolean transferenciaExterna(String origen, String destino, String importe) {
        Calendar c=Calendar.getInstance();
        float comision=1;
        if(origen.compareTo(destino)!=0)
            if(this.anadirMovimiento(origen, (Float.parseFloat(importe)*-1)+comision, "Transferencia interna", c.getTime()) == true) {
                this.envioCECA(destino,importe,"Transferencia");
                return true;
            }
        return false;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2CC720E9-7E27-DCC2-5776-2D77B432D580]
    // </editor-fold> 
    public String verRemesa (String path) {
        String resumenRemesa = "";
        try
        {
            FileReader fr = null;
            fr = new FileReader(path);
            BufferedReader bf = new BufferedReader(fr);
            String linea;
            while ((linea = bf.readLine()) != null) {
                if (linea.substring(0 ,4).compareTo("5180")==0)
                { //leo presentador
                    resumenRemesa+=linea.substring(28, 68)+"\n";
                }
                else
                {
                   if(linea.substring(0, 4).compareTo("5680")==0)
                      resumenRemesa+=linea.substring(28, 68)+"\t"+linea.substring(88, 98)+"\n";
                }
           }
        }
        catch (IOException ex)
        {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
        return resumenRemesa;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F6137D90-5864-98E0-69F6-C2C70043B992]
    // </editor-fold> 
    public void incorporaRemesa (String path) throws ParseException {
        try {
            FileReader fr = null;
            fr = new FileReader(path);
            BufferedReader bf = new BufferedReader(fr);
            String linea;
            String fechaRemesa="";
            String NumeroCuenta="";
            while ((linea = bf.readLine()) != null) {
                if (linea.substring(0 ,4).compareTo("5180")==0) { //leo presentador
                    int i=this.posTitularNombre(linea.substring(28,68).trim());
                    if(i!=-1) {
                        Remesa rem = new Remesa();
                        rem.setOrdenante(mProducto.get(i).getTitular().get(0));
                        mRemesa.add(rem);
                    }
                } else if(linea.substring(0,4).compareTo("5380")==0) {
                    SimpleDateFormat df=new SimpleDateFormat("ddMMyy");
                    fechaRemesa=linea.substring(22, 28);
                    this.getRemesa().get(this.getRemesa().size()-1).setFechaOperacion(df.parse(fechaRemesa));
                    NumeroCuenta=linea.substring(68,88);
                }
                else if(linea.substring(0,4).compareTo("5880")==0) {
                    DecimalFormat df1 = new DecimalFormat("######,##");
                    Number n=df1.parse(linea.substring(88,98));
                    SimpleDateFormat df2=new SimpleDateFormat("ddMMyy");
                    this.anadirMovimiento(NumeroCuenta,n.floatValue(),"Abono remesa de cargos",df2.parse(fechaRemesa));
                }
                else if(linea.substring(0, 4).compareTo("5680")==0) {
                    OperRemesa oper= new OperRemesa();
                    int i=this.posCuenta(linea.substring(68, 88));
                       if(i!=-1) {
                           DecimalFormat df1 = new DecimalFormat("######,##");
                           Number n=df1.parse(linea.substring(88,98));
                           oper.setCambioSaldo(n.floatValue()*-1);
                           oper.setDescripcion("Cargo de "+mRemesa.get(mRemesa.size()-1).getOrdenante().getNombre());
                           SimpleDateFormat df2=new SimpleDateFormat("ddMMyy");
                           oper.setFechaOperacion(df2.parse(fechaRemesa));
                           mProducto.get(i).getMovimiento().add(oper);
                           mRemesa.get(mRemesa.size()-1).addOperRemesa(oper);
                       }
                   }
           }
        }
        catch (IOException ex)
        {
            Logger.getLogger(Sucursal.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0AF773C9-5275-2564-9FB0-6B89E1C80748]
    // </editor-fold> 
    public int posCuenta (String nCuenta) {
        for(int i=0;i<mProducto.size();i++)
            if(mProducto.get(i).getNumeroProducto().compareTo(nCuenta)==0)
                return i;
        return -1;
    }

    public int posTitularID (String ident) {
        for(int i=0;i<mTitular.size();i++)
            if(mTitular.get(i).getId().compareTo(ident)==0)
                return i;
        return -1;
    }

    public int posTitularNombre (String nombre) {
        for(int i=0;i<mTitular.size();i++)
            if(mTitular.get(i).getNombre().compareTo(nombre)==0)
                return i;
        return -1;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FFEA940E-EFB5-B736-68C1-38472BB7ADCB]
    // </editor-fold> 
    public boolean anadirMovimiento (String nCuenta, float importe, String descrip, Date fecha) {
        if(mProducto.get(posCuenta(nCuenta)).getSaldo()+importe<0 && importe<0) {
            return false; //da error
        }
        else { //TRATAMIENTO DE ERROR. Sólo entra si control (de error) es "true"
            Movimiento nuevo=new Movimiento();
            nuevo.setCambioSaldo(importe);
            nuevo.setDescripcion(descrip);
            nuevo.setFechaOperacion(fecha);
            mProducto.get(posCuenta(nCuenta)).getMovimiento().add(nuevo);
            return true;
        }
    }

    private void envioCECA(String destino, String importe, String descripcion) {
        //hay que hacer el envio a la CECA
    }
}

